
//json2.js
var JSON; if (!JSON) { JSON = {} } (function () { function f(n) { return n < 10 ? "0" + n : n } if (typeof Date.prototype.toJSON !== "function") { Date.prototype.toJSON = function (key) { return isFinite(this.valueOf()) ? this.getUTCFullYear() + "-" + f(this.getUTCMonth() + 1) + "-" + f(this.getUTCDate()) + "T" + f(this.getUTCHours()) + ":" + f(this.getUTCMinutes()) + ":" + f(this.getUTCSeconds()) + "Z" : null }; String.prototype.toJSON = Number.prototype.toJSON = Boolean.prototype.toJSON = function (key) { return this.valueOf() } } var cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g, escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g, gap, indent, meta = { "\b": "\\b", "\t": "\\t", "\n": "\\n", "\f": "\\f", "\r": "\\r", '"': '\\"', "\\": "\\\\" }, rep; function quote(string) { escapable.lastIndex = 0; return escapable.test(string) ? '"' + string.replace(escapable, function (a) { var c = meta[a]; return typeof c === "string" ? c : "\\u" + ("0000" + a.charCodeAt(0).toString(16)).slice(-4) }) + '"' : '"' + string + '"' } function str(key, holder) { var i, k, v, length, mind = gap, partial, value = holder[key]; if (value && typeof value === "object" && typeof value.toJSON === "function") { value = value.toJSON(key) } if (typeof rep === "function") { value = rep.call(holder, key, value) } switch (typeof value) { case "string": return quote(value); case "number": return isFinite(value) ? String(value) : "null"; case "boolean": case "null": return String(value); case "object": if (!value) { return "null" } gap += indent; partial = []; if (Object.prototype.toString.apply(value) === "[object Array]") { length = value.length; for (i = 0; i < length; i += 1) { partial[i] = str(i, value) || "null" } v = partial.length === 0 ? "[]" : gap ? "[\n" + gap + partial.join(",\n" + gap) + "\n" + mind + "]" : "[" + partial.join(",") + "]"; gap = mind; return v } if (rep && typeof rep === "object") { length = rep.length; for (i = 0; i < length; i += 1) { if (typeof rep[i] === "string") { k = rep[i]; v = str(k, value); if (v) { partial.push(quote(k) + (gap ? ": " : ":") + v) } } } } else { for (k in value) { if (Object.prototype.hasOwnProperty.call(value, k)) { v = str(k, value); if (v) { partial.push(quote(k) + (gap ? ": " : ":") + v) } } } } v = partial.length === 0 ? "{}" : gap ? "{\n" + gap + partial.join(",\n" + gap) + "\n" + mind + "}" : "{" + partial.join(",") + "}"; gap = mind; return v } } if (typeof JSON.stringify !== "function") { JSON.stringify = function (value, replacer, space) { var i; gap = ""; indent = ""; if (typeof space === "number") { for (i = 0; i < space; i += 1) { indent += " " } } else { if (typeof space === "string") { indent = space } } rep = replacer; if (replacer && typeof replacer !== "function" && (typeof replacer !== "object" || typeof replacer.length !== "number")) { throw new Error("JSON.stringify") } return str("", { "": value }) } } if (typeof JSON.parse !== "function") { JSON.parse = function (text, reviver) { var j; function walk(holder, key) { var k, v, value = holder[key]; if (value && typeof value === "object") { for (k in value) { if (Object.prototype.hasOwnProperty.call(value, k)) { v = walk(value, k); if (v !== undefined) { value[k] = v } else { delete value[k] } } } } return reviver.call(holder, key, value) } text = String(text); cx.lastIndex = 0; if (cx.test(text)) { text = text.replace(cx, function (a) { return "\\u" + ("0000" + a.charCodeAt(0).toString(16)).slice(-4) }) } if (/^[\],:{}\s]*$/.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, "@").replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, "]").replace(/(?:^|:|,)(?:\s*\[)+/g, ""))) { j = eval("(" + text + ")"); return typeof reviver === "function" ? walk({ "": j }, "") : j } throw new SyntaxError("JSON.parse") } } }());

//RS
var rapidSpellExtension = {
    useWCFService: true,

    serviceProxy: new function () {
        var _I = this;
        this.isBusy = false;
        this.appendURLString = "";
        this.commonFolderUrl = "Keyoti_RapidSpell_Web_Common";



        // *** Call a wrapped object
        this.invoke = function (method, data, callback, error, bare, POSTGET) {
            if (typeof (POSTGET) == 'undefined')
                POSTGET = "POST";
            if (rapidSpellExtension.useWCFService)
                this.serviceUrl = rapidSpellExtension.serviceProxy.commonFolderUrl + "/RapidSpellService.svc/";
       
            this.isBusy = true;


            // *** The service endpoint URL        
            var url = _I.serviceUrl + method + this.appendURLString;


            // *** Convert input data into JSON - REQUIRES Json2.js
            var json = JSON.stringify(data);
            console.log("Using WCF service .NET 4");
            $.ajax({
                url: url,
                data: json,
                type: POSTGET,
                processData: false,
                contentType: "application/json",//; charset=utf-8
                timeout: 30000,
                dataType: "text",  // not "json" we'll parse
                success:
                function (res) {
                    rapidSpellExtension.serviceProxy.isBusy = false;
                    if (!callback) return;

                    // *** Use json library so we can fix up MS AJAX dates
                    var result = JSON.parse(res);

                    if (result.exception != null && result.exception.length > 0) {
                        alert(result.exception);
                    } else {

                        //bare = true;
                        // *** Bare message IS result
                        if (bare)
                        { callback(result); return; }

                        // *** Wrapped message contains top level object node
                        // *** strip it off
                        for (var property in result) {
                            callback(result[property]);
                            break;
                        }
                    }
                },
                error: function (xhr, textstatus, message) {
                    if (xhr.status == 500 && xhr.responseText.length == 0) {
                        //rapidSpellExtension.serviceProxy.diagnoseWCFProblem();
                        alert("A 500 server error occurred, with no response message.");
                    }
                    rapidSpellExtension.serviceProxy.isBusy = false;
                    if (xhr.responseText.indexOf("Version:2.0") > -1) alert("It appears that you are running .NET 2 on the server, therefore you must call this Javascript in your page:\r\n\r\nrapidSpellExtension.useWCFService=false;\r\n\r\nDoing that will use the .NET 2 ASMX Web Service instead of .NET 4 WCF");
                    if (!error) return;
                    if (xhr.responseText) {
                        var err;
                        try {
                            err = JSON.parse(xhr.responseText);
                        } catch (ee) {
                            err = { Message: "URL:" + this.url + "\r\n\r\n" + xhr.responseText };
                        }
                        if (err) {
                            err.Message += "\r\nURL:" + this.url;
                            alert(err.Message);
                        } else
                            alert("Unknown server error." + "\r\nURL:" + this.url);
                    } else if (textstatus) {
                        if (textstatus == 'timeout') textstatus = 'Sorry the server has not responded, please try again.';
                        if (textstatus == 'error') {
                            if (xhr.status == 404) {
                                textstatus = xhr.status + ' error from server.  \r\nTry calling (in Javascript) \r\n\r\nrapidSpellExtension.commonFolderUrl = "/Keyoti_RapidSpell_Web_Common/";\r\n\r\nwith the correct path to the folder that contains RapidSpellService.svc\r\n';
                            } else
                                textstatus = xhr.status + ' error from server.';
                        }
                        alert(textstatus + "\r\n\r\nURL:" + this.url);
                    }
                    return;
                }
            });
        };
    }
}/* ]]> */
